Imports System
Imports System.Collections.Generic
Imports System.Drawing
Imports System.IO
Imports System.Windows.Forms
Imports System.Diagnostics
Imports GTA
Imports GTA.Math
Imports GTA.Native
Imports GTA.UI
Imports WeaponComponent = GTA.Native.WeaponComponent
Imports Microsoft.VisualBasic

'########################################################################################
'###################################################################################
'###########			============================================
'###########   'Army At SixStars' Dispatch Mod - Visual Basic by Nj5050 & JulioNib	
'###########			============================================	
'########### DISCLAIMER: Modify this script at your own risk. Putting in random
'###########             values could make your game do unexpected things.    ###########
'###################################################################################
'###################################################################################

Public Class ArmyAtSixStars
	Inherits Script

	Public Sub New()
		AddHandler MyBase.KeyDown, AddressOf Me.MainKeyDown
		AddHandler MyBase.Tick, AddressOf Me.MainTick
		Me.myRandomSource = New Random(DateAndTime.Now.Millisecond)
		Me.bSixStars = False
		Me.crimes = 0
		Me.damagedPeds = New List(Of Integer)()
		Me.copsGroup = Nothing
		Me.relationshipGroup = Nothing
		Me.bLoadAnimatedGif = True
		Me.animatedGifFiles_1 = New List(Of String)()
		Me.animatedGifFiles_currentImages = New List(Of String)()
		Me.latestCopCarHeading = 0.0
		Me.latestCopCarSpeed = 0.0
		Me.createdVehicles = New List(Of Integer)()
		Me.createdEntities = New List(Of Entity)()
		MyBase.Interval = 10
	End Sub

	Public Sub MainKeyDown(sender As Object, e As KeyEventArgs)
		If e.KeyCode = Keys.Subtract Then	'For Resetting Entire script by pressing the, " - " or minus key.
			ResetScriptState()
		End If
	End Sub

	Public Sub MainTick(sender As Object, e As EventArgs)
    		Me.WantedTick()
	End Sub

	Private Sub WantedTick()
		'for testing, jump into wanted
		'Me.crimes = 150
		'Me.bSixStars = True

		Dim flag As Boolean = Game.Player.WantedLevel = 5
		If flag Then

			Dim flag2 As Boolean = Not Me.bSixStars
			If flag2 Then
				Dim IsShooting As Boolean = Game.Player.Character.IsShooting
				If IsShooting Then
					Dim ptr As Integer = Me.crimes
					Me.crimes = ptr + 10
				End If
				Dim IsJacking As Boolean = Game.Player.Character.IsJacking
				If IsJacking Then
					Dim ptr As Integer = Me.crimes
					Me.crimes = ptr + 2
				End If
				Dim flag3 As Boolean = DateAndTime.Now.Subtract(Me.timerCheckKilledPeds).TotalMilliseconds > 1000.0
				If flag3 Then
					Me.timerCheckKilledPeds = DateAndTime.Now
					For Each ped As Ped In World.GetNearbyPeds(Game.Player.Character.Position, 100.0F)
						Try
							Dim flag4 As Boolean = Entity.Exists(ped) AndAlso Not Me.damagedPeds.Contains(ped.Handle) AndAlso ped.HasBeenDamagedBy(Game.Player.Character)
							If flag4 Then
								Me.damagedPeds.Add(ped.Handle)
								Dim ptr As Integer = Me.crimes
								Me.crimes = ptr + 10
							End If
						Catch ex As Exception
						End Try
					Next
				End If

				Dim flag5 As Boolean = Me.crimes > 150

				If flag5 Then
					Me.bSixStars = True
					Me.bShowWNews = True ' Set bShowWNews to True when the player reaches a six-star wanted level
					Me.timerShowWNews = DateAndTime.Now ' Set the timer to Now when the player reaches a six-star wanted level

					' Display US President UI notification message here
					UI.Notify("~w~This is the US President speaking. There's report of a high-level threat in Los Santos. All available ~g~Local, Federal & Military Agencies, ~w~have been mobilized to respond. Please remain calm and stay indoors until further notice.", False)
				End If

				UI.ShowSubtitle(Me.crimes.ToString() + "/150", 10)
			End If
		Else

			Me.crimes = 0
			Me.bSixStars = False
			Me.bShowWNews = False  ' Reset bShowWNews to False when the player's wanted level is less than six stars
		End If

		Dim flag6 As Boolean = Me.bSixStars
		If flag6 Then

			If Me.bShowWNews AndAlso (DateTime.Now.Subtract(Me.timerShowWNews).TotalMilliseconds < 13000) Then  ' Display the News GIF animation playback image for 13 seconds
				' Call the method that draws the GIF image
				Me.DrawWezelNews()
			Else
				Me.bShowWNews = False ' Reset bShowWNews to False after the News GIF animation playback image has been displayed for 10 seconds
			End If

			' Draw the star GIF image only when bSixStars is True
			If Me.bSixStars Then

				Dim pos As Point = New Point(1145, 10)
				Dim size As Size = New Size(21, 20)

				UI.DrawTexture(".\scripts\army v3\star.gif", 0, 10, 100, pos, size)
			End If

			If DateAndTime.Now.Subtract(Me.timerShowWNews).TotalMilliseconds >= 13000 Then
				Me.bShowWNews = False ' Reset bShowWNews to False after 13 seconds
			End If

			Dim flag7 As Boolean = DateAndTime.Now.Subtract(Me.timerDispatch).TotalMilliseconds > 10100.0
			If flag7 AndAlso bSixStars Then            'Adds a second check for bSixStars here
				Me.timerDispatch = DateAndTime.Now
	
				'first, let's make all recenlty created entities as no longer needed, so game can delete them
				Dim num As Integer = Me.createdEntities.Count - 1
				For c As Integer = num To 0 Step -1
					Dim flag8 As Boolean = Entity.Exists(Me.createdEntities(c))
					If flag8 Then

						Dim flag9 As Boolean = World.GetDistance(Me.createdEntities(c).Position, Game.Player.Character.Position) > 200.0F
						If flag9 Then
							Me.createdEntities(c).MarkAsNoLongerNeeded()
						End If
					Else
						Me.createdEntities.RemoveAt(c)
					End If
				Next

				'only creates if there is less than 50 entities created and existing
				Dim Flag10 As Boolean = Me.createdEntities.Count < 50
				If Flag10 Then

					Dim IsInWater As Boolean = Game.Player.Character.IsInWater
					Dim Flag11 As Boolean = IsInWater
					If Flag11 Then

						Me.Coastguard_heliselect()
					End If

					Dim IsInBoat As Boolean = Game.Player.Character.IsInBoat
					Dim Flag12 As Boolean = IsInBoat
					If Flag12 Then

						Me.Coastguard_heliselect()
					End If

					Dim IsInBoat2 As Boolean = Game.Player.Character.IsInBoat
					Dim Flag13 As Boolean = IsInBoat
					If Flag13 Then

						Me.NavySeal_select()
					End If

					Dim IsInWater2 As Boolean = Game.Player.Character.IsInWater
					Dim Flag14 As Boolean = IsInWater
					If Flag14 Then

						Me.NavySeal_select()
					End If

					Dim IsSwimming As Boolean = Game.Player.Character.IsSwimming
					Dim Flag15 As Boolean = IsSwimming
					If Flag15 Then

						Me.Coastguard_heliselect()
					End If

					Dim IsInSub As Boolean = Game.Player.Character.IsInSub
					Dim Flag16 As Boolean = IsInSub
					If Flag16 Then

						Me.Coastguard_heliselect()
					End If

					Dim IsSwimmingUnderWater As Boolean = Game.Player.Character.IsSwimmingUnderWater
					Dim Flag17 As Boolean = IsSwimmingUnderWater
					If Flag17 Then

						Me.Coastguard_heliselect()
					End If

					Dim IsInSub2 As Boolean = Game.Player.Character.IsInSub
					Dim Flag18 As Boolean = IsInSub
					If Flag18 Then

						Me.Navy_Fleetselect()

					UI.Notify("~b~US Naval Fleets Have Been Dispatched Throughout The Seas Of SA, In Pursuit Of ~r~Wanted Suspect.", False)
					End If

					Dim IsInBoat3 As Boolean = Game.Player.Character.IsInBoat
					Dim Flag19 As Boolean = IsInBoat
					If Flag19 Then

						Me.Navy_Fleetselect()

					UI.Notify("~b~US Naval Fleets Have Been Dispatched Throughout The Seas Of SA, In Pursuit Of ~r~Wanted Suspect.", False)
					End If

					Dim IsInSub3 As Boolean = Game.Player.Character.IsInSub
					Dim Flag20 As Boolean = IsInSub
					If Flag20 Then

						Me.Navy_Subselect()

					UI.Notify("~b~US Navy Sub Units Have Been Dispatched Throughout The Seas Of SA, In Pursuit Of ~r~Wanted Suspect.", False)
					End If

					Dim IsSwimmingUnderWater2 As Boolean = Game.Player.Character.IsSwimmingUnderWater
					Dim Flag21 As Boolean = IsSwimmingUnderWater
					If Flag21 Then

						Me.NavySeal_select()
					End If

					Dim IsRunning As Boolean = Game.Player.Character.IsRunning
					Dim Flag22 As Boolean = IsRunning
					If Flag22 Then

						Me.NationalGuard_select()
					End If

					Dim IsShooting As Boolean = Game.Player.Character.IsShooting
					Dim Flag23 As Boolean = IsShooting
					If Flag23 Then

						Me.NationalGuard_select()
					End If

					Dim IsWalking As Boolean = Game.Player.Character.IsWalking
					Dim Flag24 As Boolean = IsWalking
					If Flag24 Then

						Me.NationalGuard_select()
					End If

					Dim IsOnFoot As Boolean = Game.Player.Character.IsOnFoot
					Dim Flag25 As Boolean = IsOnFoot
					If Flag25 Then

						Me.NationalGuard_select()
					End If

					Dim IsInPoliceVehicle As Boolean = Game.Player.Character.IsInPoliceVehicle
					Dim Flag26 As Boolean = IsInPoliceVehicle
					If Flag26 Then

						Me.Army_Tankselect()

					UI.Notify("~w~Suspect Is Reportedly In A Police Armored Vehicle.~g~US Army Ground Tank Units ~w~Have Now Been Deployed Throughout Los Santos, In Search Of ~r~Wanted Suspect.", False)
					End If

					Dim IsInGroup As Boolean = Game.Player.Character.IsInGroup
					Dim Flag27 As Boolean = IsInGroup
					If Flag27 Then

						Me.NationalGuard_select()
					End If

					Dim IsSprinting As Boolean = Game.Player.Character.IsSprinting
					Dim Flag28 As Boolean = IsSprinting
					If Flag28 Then

						Me.Fib_Tacticalselect()

					UI.Notify("~w~US FIB Tactical Units Have Been Dispatched Throughout Los Santos, In The Hunt For ~r~Wanted Suspect.", False)
					End If

					Dim IsInMeleeCombat As Boolean = Game.Player.Character.IsInMeleeCombat
					Dim Flag29 As Boolean = IsInMeleeCombat
					If Flag29 Then

						Me.Fib_Tacticalselect()

					UI.Notify("~w~US FIB Tactical Units Have Been Dispatched Throughout Los Santos, In The Hunt For ~r~Wanted Suspect.", False)
					End If

					Dim IsonFoot2 As Boolean = Game.Player.Character.IsonFoot
					Dim Flag30 As Boolean = IsonFoot2
					If Flag30 Then

						Me.Fib_Tacticalselect()

					' UI.Notify("~w~US FIB Tactical Units Have Been Dispatched Throughout Los Santos, In The Hunt For ~r~Wanted Suspect.", False)
					End If


				'only creates if there is less than 22 entities created and existing
					Dim Flag31 As Boolean = Me.createdEntities.Count < 22
					If Flag31 Then

					Dim IsSprinting2 As Boolean = Game.Player.Character.IsSprinting
					Dim Flag32 As Boolean = IsSprinting
				    If Flag32 Then

						Me.Airforce_ParaTrooperselect()

						UI.Notify("~w~US AirForce & Black Ops. Paratroopers Are Now Inbound. ~o~So By The Time You Look Up, They've Already Infiltrated Your Area.", False)
						End If

					Dim IsRunning2 As Boolean = Game.Player.Character.IsRunning
					Dim Flag33 As Boolean = IsRunning
				    If Flag33 Then

						Me.Airforce_ParaTrooperselect()

						UI.Notify("~w~US AirForce & Black Ops. Paratroopers Are Now Inbound. ~o~So By The Time You Look Up, They've Already Infiltrated Your Area.", False)
						End If

					Dim IsClimbing As Boolean = Game.Player.Character.IsClimbing
					Dim Flag34 As Boolean = IsClimbing
				    If Flag34 Then

						Me.Airforce_ParaTrooperselect()

						UI.Notify("~w~US AirForce & Black Ops. Paratroopers Are Now Inbound. ~o~So By The Time You Look Up, They've Already Infiltrated Your Area.", False)
						End If


				'only creates if there is less than 12 entities created and existing
					Dim Flag35 As Boolean = Me.createdEntities.Count < 12
					If Flag35 Then

					Dim IsInAir As Boolean = Game.Player.Character.IsInAir
					Dim Flag36 As Boolean = IsInAir
					If Flag36 Then

						Me.Airforce_SpaceForceselect()

					UI.Notify("~o~US SpaceForce Operatives ~w~Have Now Been Dispatched Throughout The Skies Of Los Santos, To Intercept ~r~Wanted Suspect.", False)
					End If

					Dim IsInFlyingVehicle As Boolean = Game.Player.Character.IsInFlyingVehicle
					Dim Flag37 As Boolean = IsInFlyingVehicle
					If Flag37 Then

						Me.Airforce_SpaceForceselect()

					UI.Notify("~o~US SpaceForce Operatives ~w~Have Now Been Dispatched Throughout The Skies Of Los Santos, To Intercept ~r~Wanted Suspect.", False)
					End If

				'only creates if there is less than 50 entities created and existing
				Dim Flag38 As Boolean = Me.createdEntities.Count < 50
				If Flag38 Then

					Dim Flag39 As Boolean = Game.Player.Character.IsInVehicle()
					If Flag39 Then

						 Dim IsHelicopter As Boolean = Game.Player.Character.CurrentVehicle.Model.IsHelicopter OrElse Game.Player.Character.CurrentVehicle.Model.IsPlane OrElse Game.Player.Character.CurrentVehicle.Model.IsTrain OrElse Game.Player.Character.CurrentVehicle.Model.IsCargobob
						 If IsHelicopter Then

							 Me.Airforce_SpaceForceselect()

						 UI.Notify("~o~US SpaceForce Operatives ~w~Have Now Been Dispatched Throughout The Skies Of Los Santos, To Intercept ~r~Wanted Suspect.", False)
						 End If

						Dim IsBoat As Boolean = Game.Player.Character.CurrentVehicle.Model.IsBoat
						If IsBoat Then

							Me.Coastguard_heliselect()
						End If

						Dim IsBike As Boolean = Game.Player.Character.CurrentVehicle.Model.IsBike OrElse Game.Player.Character.CurrentVehicle.Model.IsCar OrElse Game.Player.Character.CurrentVehicle.Model.IsTrain
						If IsBike Then

							Me.Cia_bikeselect()

						UI.Notify("~w~US CIA/IAA Operatives Have Been Dispatched Throughout Los Santos, In The Hunt For ~r~Wanted Suspect.", False)
						End If

						Dim Istank As Boolean = Game.Player.Character.CurrentVehicle.Model.IsCar OrElse Game.Player.Character.CurrentVehicle.Model = VehicleHash.Khanjari OrElse Game.Player.Character.CurrentVehicle.Model = VehicleHash.APC OrElse Game.Player.Character.CurrentVehicle.Model = VehicleHash.Rhino OrElse Game.Player.Character.CurrentVehicle.Model.Hash = 1542143200UI  ' Hash value for Scarab2
						If Istank Then

							Me.Army_Tankselect()

						UI.Notify("~w~Suspect Is Reportedly In An Armored Vehicle.~g~US Army Tank Units ~w~Have Now Been Deployed Throughout Los Santos, In Search Of ~r~Wanted Suspect.", False)
						End If

						Dim IsCar As Boolean = Game.Player.Character.CurrentVehicle.Model.IsCar OrElse Game.Player.Character.Model.IsQuadbike OrElse Game.Player.Character.CurrentVehicle.Model.IsBike OrElse Game.Player.Character.CurrentVehicle.Model.IsTrain
						If IsCar Then

							Me.NationalGuard_select()
						End If

						Dim IsCar2 As Boolean = Game.Player.Character.CurrentVehicle.Model.IsCar OrElse Game.Player.Character.CurrentVehicle.Model.IsTrain
						If IsCar2 Then

							Me.Fib_Tacticalselect()
						End If

						Dim IsBoat2 As Boolean = Game.Player.Character.CurrentVehicle.Model.IsBoat
						If IsBoat2 Then

							Me.NavySeal_select()
						End If

						Dim IsBoat3 As Boolean = Game.Player.Character.CurrentVehicle.Model.IsBoat
						If IsBoat3 Then

							Me.Navy_Fleetselect()
					End If

						If Game.Player.Character.IsInVehicle() AndAlso (Game.Player.Character.CurrentVehicle.ClassType = VehicleClass.Military)

							Me.Army_Tankselect()

							UI.Notify("~w~Suspect Is Reportedly In A Armored Military Vehicle.~g~US Army Tank Units ~w~Have Now Been Deployed Throughout Los Santos, In Search Of ~r~Wanted Suspect.", False)
						End If
					Else

						Dim Flag40 As Boolean = Not Game.Player.Character.IsInWater AndAlso Not Game.Player.Character.IsInAir
						Dim Flag41 As Boolean = Flag40
						If Flag41 Then

							Me.NationalGuard_select()
						Else

 							Me.Airforce_SpaceForceselect()
					 End If
				   End If
			     End If
		       End If
	         End If
	    End If
	End If
     End If
  End Sub

	Private Sub DrawWezelNews()

		Dim flag As Boolean = Me.bLoadAnimatedGif
		If flag Then
			Me.bLoadAnimatedGif = False
			Me.animatedGifFiles_1.Clear()
			For Each item As String In Directory.GetFiles(".\scripts\army v3\gif\anim1")
				Me.animatedGifFiles_1.Add(item)
			Next
		End If
		Dim flag2 As Boolean = Me.animatedGifFiles_1.Count > 0
		If flag2 Then
			Dim flag3 As Boolean = DateAndTime.Now.Subtract(Me.animatedGig_timerNextImage).TotalMilliseconds > 20.0
			If flag3 Then
				Me.animatedGig_timerNextImage = DateAndTime.Now
				Dim flag4 As Boolean = Me.animatedGifFiles_currentImages.Count = 0
				If flag4 Then
					Me.animatedGifFiles_currentImages.AddRange(Me.animatedGifFiles_1)
				End If
				UI.DrawTexture(Me.animatedGifFiles_currentImages(0), 0, 0, 100, New Point(0, 0), New Size(249, 139))
				Me.animatedGifFiles_currentImages.RemoveAt(0)
			End If
		End If
	End Sub

	Private Sub AddVehModelToList(ByRef pList As List(Of String), pModel As String)

		Dim flag As Boolean = [Function].[Call](Of Boolean)(Hash._0x35B9E0803292B641, New InputArgument() {New Model(pModel).Hash})
		If flag Then
			pList.Add(pModel)
		End If
	End Sub

	Private Sub NationalGuard_select()

		Dim list As List(Of String) = New List(Of String)()

		Me.AddVehModelToList(list, "crusader")	 '1
		Me.AddVehModelToList(list, "uparmorw")	 '2
		Me.AddVehModelToList(list, "hasrad")	 '3
		Me.AddVehModelToList(list, "mrap")	 '4
		Me.AddVehModelToList(list, "barracks")	  '5
		Me.AddVehModelToList(list, "barracks3")	  '6
		Me.AddVehModelToList(list, "insurgent")	  '7
		Me.AddVehModelToList(list, "Uparmor")	  '8
		Me.AddVehModelToList(list, "hmvs")	   '9
		Me.AddVehModelToList(list, "barrage")	    '10
		Me.addVehModelToList(list, "minitank")        '11

		Dim flag As Boolean = list.Count = 0
		If Not flag Then
			Dim source As String = list(Me.myRandomSource.[Next](0, list.Count))
			Dim vehicle As Vehicle = World.CreateVehicle(source, Me.GetSpawnPos(90.0) + Vector3.WorldUp * 2.0F)

			Script.Wait(5)

			Dim flag2 As Boolean = Entity.Exists(vehicle)
			If flag2 Then
				Me.createdVehicles.Add(vehicle.Handle)
				Me.createdEntities.Add(vehicle)

				Dim flag3 As Boolean = Not Me.CheckDist(vehicle)
				If flag3 Then

					vehicle.PlaceOnGround()

					Dim list2 As List(Of VehicleSeat) = New List(Of VehicleSeat)()
					list2.Add(VehicleSeat.Driver)    '1
					list2.Add(VehicleSeat.Passenger)  '2
					list2.Add(VehicleSeat.RightRear)  '3
					list2.Add(VehicleSeat.LeftRear)   '4
					list2.Add(VehicleSeat.ExtraSeat5)  '5
					list2.Add(VehicleSeat.ExtraSeat6)  '6
					list2.Add(VehicleSeat.ExtraSeat7)  '7
					list2.Add(VehicleSeat.ExtraSeat8)  '8

					Dim list3 As List(Of WeaponHash) = New List(Of WeaponHash)()
					list3.Add(Me.Weapselect())  '1
					list3.Add(Me.Weapselect())   '2
					list3.Add(Me.Weapselect())    '3
					list3.Add(Me.Weapselect())     '4
					list3.Add(Me.Weapselect())      '5
					list3.Add(Me.Weapselect())       '6
					list3.Add(Me.Weapselect())        '7
					list3.Add(Me.Weapselect())        '8

					Dim list4 As List(Of WeaponComponent) = New List(Of WeaponComponent)()
					list4.Add(Me.Weapcomponselect())  '1
					list4.Add(Me.Weapcomponselect())  '2
					list4.Add(Me.Weapcomponselect())  '3
					list4.Add(Me.Weapcomponselect())  '4
					list4.Add(Me.Weapcomponselect())  '5
					list4.Add(Me.Weapcomponselect())  '6
					list4.Add(Me.Weapcomponselect())  '7
					list4.Add(Me.Weapcomponselect())  '8
					Try
						For Each vehicleSeat As VehicleSeat In list2
							Dim ped As Ped = vehicle.CreatePedOnSeat(vehicleSeat, Me.Army_Pedselect())

							Script.Wait(5)

							Dim flag4 As Boolean = Entity.Exists(ped)
							If flag4 Then
								Me.createdEntities.Add(ped)
								Me.SetAsCop(ped)

								Dim flag5 As Boolean = list3.Count = 0
								If flag5 Then

									list3.Add(Me.Weapselect())
									list4.Add(Me.Weapcomponselect())
								End If

								'give actual weapon and then remove it from the weapons list, this way we will equip each soldier with one weapon from the list
								ped.Weapons.Give(list3(0), 999, True, True)

								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.AdvancedRifle, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.CarbineRifle, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.BullpupRifle, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.SpecialCarbine, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.SMG, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.AssaultSMG, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.HeavyShotgun, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.AssaultShotgun, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.MarksmanRifle, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.Pistol, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.CombatPistol, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.CombatPDW, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.Pistol50, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.HeavyPistol, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.Revolver, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.GrenadeLauncher, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.PumpShotgun, WeaponComponent.AtArFlsh})

								list3.RemoveAt(0)
								list4.RemoveAt(0)

								'set the shooting task for each soldier
								Dim flag6 As Boolean = vehicleSeat = vehicleSeat.Driver
								If flag6 Then

									ped.Task.ShootAt(Game.Player.Character, 99999, CType(3607063905UI, FiringPattern))
									ped.DrivingStyle = DrivingStyle.Normal
									ped.AlwaysKeepTask = True
								Else

									ped.Task.FightAgainst(Game.Player.Character, 9999)
								End If

								'set that they may be deleted by the game
								ped.MarkAsNoLongerNeeded()
							End If
						Next
					Finally
						Dim enumerator As List(Of VehicleSeat).Enumerator
						CType(enumerator, IDisposable).Dispose()
						vehicle.MarkAsNoLongerNeeded()
					End Try

					Dim flag7 As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
					If flag7 Then
						vehicle.Heading = CSng(Me.latestCopCarHeading)
						vehicle.Speed = CSng(Me.latestCopCarSpeed)
					End If
				End If
			End If
		End If
	End Sub

	Private Sub Fib_Tacticalselect()

		Dim list As List(Of String) = New List(Of String)()

		Me.AddVehModelToList(list, "Centurionfib")

		Dim flag As Boolean = list.Count = 0
		If Not flag Then
			Dim source As String = list(Me.myRandomSource.[Next](0, list.Count))
			Dim vehicle As Vehicle = World.CreateVehicle(source, Me.GetSpawnPos(95.0) + Vector3.WorldUp * 2.0F)

		Script.Wait(5)

			Dim flag2 As Boolean = Entity.Exists(vehicle)
			If flag2 Then
				Me.createdVehicles.Add(vehicle.Handle)
				Me.createdEntities.Add(vehicle)

				vehicle.LightsOn = True
				vehicle.SirenActive = True

				Dim flag3 As Boolean = Not Me.CheckDist(vehicle)
				If flag3 Then

					vehicle.PlaceOnGround()

					Dim list2 As List(Of VehicleSeat) = New List(Of VehicleSeat)()
					list2.Add(VehicleSeat.Driver)    '1
					list2.Add(VehicleSeat.Passenger)  '2
					list2.Add(VehicleSeat.RightRear)  '3
					list2.Add(VehicleSeat.LeftRear)   '4
						list2.Add(VehicleSeat.ExtraSeat9)  '5
						list2.Add(VehicleSeat.ExtraSeat10)  '6
						list2.Add(VehicleSeat.ExtraSeat11)  '7
						list2.Add(VehicleSeat.ExtraSeat12)  '8

					Dim list3 As List(Of WeaponHash) = New List(Of WeaponHash)()
					list3.Add(Me.Weapselect())  '1
					list3.Add(Native.WeaponHash.Minigun)    '2
					list3.Add(Native.WeaponHash.Minigun)     '3
					list3.Add(Me.Weapselect())     		'4
					list3.Add(Me.Weapselect())          '5
					list3.Add(Me.Weapselect())         '6
					list3.Add(Me.Weapselect())        '7
					list3.Add(Me.Weapselect())        '8

					Dim list4 As List(Of WeaponComponent) = New List(Of WeaponComponent)()
					list4.Add(Me.Weapcomponselect())  '1
					list4.Add(Me.Weapcomponselect())  '2
					list4.Add(Me.Weapcomponselect())  '3
					list4.Add(Me.Weapcomponselect())  '4
					list4.Add(Me.Weapcomponselect())  '5
					list4.Add(Me.Weapcomponselect())  '6
					list4.Add(Me.Weapcomponselect())  '7
					list4.Add(Me.Weapcomponselect())  '8

					Try
						For Each vehicleSeat As VehicleSeat In list2
						  
						  Dim ped As Ped = vehicle.CreatePedOnSeat(vehicleSeat, Me.Fib_Pedselect())

						Script.Wait(5)

							Dim flag4 As Boolean = Entity.Exists(ped)
							If flag4 Then
								Me.createdEntities.Add(ped)
								Me.SetAsCop(ped)

								Dim flag5 As Boolean = list3.Count = 0
								If flag5 Then

									list3.Add(Me.Weapselect())
									list4.Add(Me.Weapcomponselect())
							End If

								'give actual weapon and then remove it from the weapons list, this way we will equip each soldier with one weapon from the list
								ped.Weapons.Give(list3(0), 999, True, True)

								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.AdvancedRifle, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.CarbineRifle, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.BullpupRifle, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.SpecialCarbine, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.SMG, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.AssaultSMG, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.HeavyShotgun, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.AssaultShotgun, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.MarksmanRifle, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.Pistol, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.CombatPistol, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.CombatPDW, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.Pistol50, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.HeavyPistol, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.Revolver, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.GrenadeLauncher, WeaponComponent.AtArFlsh})
								[Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() {ped, WeaponHash.PumpShotgun, WeaponComponent.AtArFlsh})

								list3.RemoveAt(0)
								list4.RemoveAt(0)

								'set the shooting task for each soldier
								Dim flag6 As Boolean = vehicleSeat = vehicleSeat.Driver
								If flag6 Then

									ped.Task.ShootAt(Game.Player.Character, 9999)  'BurstFire = 3607063905UI / FullAuto = 3337513804UI
									ped.DrivingStyle = DrivingStyle.Rushed
									ped.RelationshipGroup = IsCop(ped)
									ped.AlwaysKeepTask = True
								Else

									ped.Task.FightAgainst(Game.Player.Character, 9999)
								End If

								'set that they may be deleted by the game
								ped.MarkAsNoLongerNeeded()
							End If
						Next
					Finally
						Dim enumerator As List(Of VehicleSeat).Enumerator
						CType(enumerator, IDisposable).Dispose()
						vehicle.MarkAsNoLongerNeeded()
					End Try

					Dim flag7 As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
					If flag7 Then
						vehicle.Heading = Game.Player.Character.CurrentVehicle.Heading
						vehicle.Speed = Game.Player.Character.CurrentVehicle.Speed
					End If
				End If
			End If
		End If
	End Sub

	Private Sub Army_Tankselect()

		Dim list As List(Of String) = New List(Of String)()

		Me.AddVehModelToList(list, "pl01desert")
		Me.AddVehModelToList(list, "abrams")
		Me.AddVehModelToList(list, "m3a3")
		Me.AddVehModelToList(list, "lavadadv")

		Dim flag As Boolean = list.Count = 0
		If Not flag Then

			Dim source As String = list(Me.myRandomSource.[Next](0, list.Count))
			Dim vehicle As Vehicle = World.CreateVehicle(source, Me.GetSpawnPos(110.0) + Vector3.WorldUp * 2.0F)

			Script.Wait(5)

			Dim flag2 As Boolean = Entity.Exists(vehicle)
			If flag2 Then
				Me.createdEntities.Add(vehicle)
				Me.createdVehicles.Add(vehicle.Handle)

				Dim flag3 As Boolean = Not Me.CheckDist(vehicle)
				If flag3 Then

					Dim list2 As List(Of VehicleSeat) = New List(Of VehicleSeat)()
					list2.Add(VehicleSeat.Driver)
					list2.Add(VehicleSeat.Passenger)

					Dim list3 As List(Of WeaponHash) = New List(Of WeaponHash)()
					list3.Add(Me.Weapselect())
					list3.Add(Me.Weapselect())
					Try
						For Each vehicleSeat As VehicleSeat In list2
							Dim ped As Ped = vehicle.CreatePedOnSeat(vehicleSeat, "delta")

							Script.Wait(5)

							Dim flag4 As Boolean = Entity.Exists(ped)
							If flag4 Then
								Me.createdEntities.Add(ped)
								Me.SetAsCop(ped)

								'check if there still weapons in the list, use default case its empty
								Dim flag5 As Boolean = list3.Count = 0
								If flag5 Then
									list3.Add(Me.Weapselect())
								End If

								'give actual weapon and then remove it from the weapons list, this way we will equip each soldier with one weapon from the list
								ped.Weapons.Give(list3(0), 999, True, True)

								list3.RemoveAt(0)

								'set the shooting task for each soldier

								Dim flag6 As Boolean = vehicleSeat = vehicleSeat.Driver
								If flag6 Then

									ped.Task.VehicleShootAtPed(Game.Player.Character)
									ped.CanSwitchWeapons = True
									ped.DrivingStyle = DrivingStyle.Normal
									ped.RelationshipGroup = IsCop(ped)
									ped.AlwaysKeepTask = True
								Else

									ped.Task.ShootAt(Game.Player.Character, 99999, CType(3607063905UI, FiringPattern))
								End If

								'set that they may be deleted by the game
								ped.MarkAsNoLongerNeeded()
							End If
						Next
					Finally
						Dim enumerator As List(Of VehicleSeat).Enumerator
						CType(enumerator, IDisposable).Dispose()
						vehicle.MarkAsNoLongerNeeded()
					End Try

					Dim flag7 As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
					If flag7 Then
						vehicle.Heading = Game.Player.Character.CurrentVehicle.Heading
						vehicle.Speed = Game.Player.Character.CurrentVehicle.Speed
					End If
				End If
			End If
		End If
	End Sub

	Private Sub Cia_bikeselect()

		Dim list As List(Of String) = New List(Of String)()

		Me.addVehModelToList(list, "vader")
		Me.addVehModelToList(list, "hakuchou")

		Dim flag As Boolean = list.Count = 0
		If Not flag Then
			Dim source As String = list(Me.myRandomSource.[Next](0, list.Count))
			Dim vehicle As Vehicle = World.CreateVehicle(source, Me.GetMotorcycleSpawnPos(45.0))

			Script.Wait(5)

			Dim flag2 As Boolean = Entity.Exists(vehicle)
			If flag2 Then
				Me.createdVehicles.Add(vehicle.Handle)
				Me.createdEntities.Add(vehicle)

					 vehicle.EnginePowerMultiplier = 50
					 vehicle.EngineTorqueMultiplier = .50

				Dim flag3 As Boolean = Not Me.checkDist(vehicle)
				If flag3 Then

					Dim list2 As List(Of VehicleSeat) = New List(Of VehicleSeat)()

					list2.Add(VehicleSeat.Driver)
					list2.Add(VehicleSeat.Passenger)

					Dim list3 As List(Of WeaponHash) = New List(Of WeaponHash)()

					list3.Add(Me.Weapselect())
					list3.Add(Me.Weapselect())
					Try
						For Each vehicleSeat As VehicleSeat In list2
							Dim ped As Ped = vehicle.CreatePedOnSeat(vehicleSeat, Me.Cia_Pedselect())

							Script.Wait(5)

							Dim flag4 As Boolean = Entity.Exists(ped)
							If flag4 Then
								Me.createdEntities.Add(ped)
								Me.setAsCop(ped)

								'peds on bikes needs a pistol to shoot, or sub machine guns
								ped.Weapons.Give(WeaponHash.MicroSMG, 999, True, True)
								
                							Dim TS As TaskSequence = New TaskSequence() 

									TS.AddTask.VehicleChase(Game.Player.Character)

									TS.AddTask.FightAgainst(Game.Player.Character)
								    TS.Close()

								ped.Task.PerformSequence(TS)
								ped.AlwaysKeepTask = True

								TS.Dispose()
							Else

								Dim flag5 As Boolean = list3.Count = 0
								If flag5 Then

									list3.Add(Me.Weapselect())

								'give actual weapon and then remove it from the weapons list, this way we will equip each soldier with one weapon from the list
								ped.Weapons.Give(list3(0), 999, True, True)

								list3.RemoveAt(0)

                                                         'set the shooting task for each soldier
								Dim flag6 As Boolean = vehicleSeat = VehicleSeat.Driver
								If flag6 Then

									ped.Task.ShootAt(Game.Player.Character, 99999, CType(3607063905UI, FiringPattern))
									ped.DrivingStyle = DrivingStyle.Rushed
									ped.RelationshipGroup = IsCop(ped)
									ped.AlwaysKeepTask = True
								Else

									ped.Task.ShootAt(Game.Player.Character, 9999)
								End If

                                                                    'set that they may be deleted by the game
                                                                        ped.MarkAsNoLongerNeeded()
								End If
						      End If
						Next
					Finally
						Dim enumerator As List(Of VehicleSeat).Enumerator
						CType(enumerator, IDisposable).Dispose()
                                                vehicle.MarkAsNoLongerNeeded()
					End Try

					Dim flag7 As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
					If flag7 Then
						vehicle.Heading = Game.Player.Character.CurrentVehicle.Heading
						vehicle.Speed = Game.Player.Character.CurrentVehicle.Speed
					End If
				End If
			End If
		End If
	End Sub

	Private Sub Navy_Subselect()

		Dim list As List(Of String) = New List(Of String)()

		Me.AddVehModelToList(list, "Kosatka")

		Dim flag As Boolean = list.Count = 0
		If Not flag Then
			Dim source As String = list(Me.myRandomSource.[Next](0, list.Count))
			Dim vector As Vector3 = Me.GetSpawnPosInWater(290.0) + Vector3.WorldDown * 10.0F

			Dim flag2 As Boolean = vector = Nothing
			If Not flag2 Then
				Dim submarine As Vehicle = World.CreateVehicle(source, vector)

				Script.Wait(5)

				Dim flag3 As Boolean = Entity.Exists(submarine)
				If flag3 Then
					Me.createdVehicles.Add(submarine.Handle)
					Me.createdEntities.Add(submarine)

                		' Set submarine properties
                			submarine.PrimaryColor = vehiclecolor.MetallicBlueSilver
					'submarine.CustomPrimaryColor = Color.Black
					'submarine.Livery = 1
                			submarine.LightsOn = True
                			submarine.IsDriveable = True
					submarine.driver.CanBeDraggedOutOfVehicle = true
                			submarine.LightsMultiplier = 2
                			submarine.EnginePowerMultiplier = 55
                			submarine.EngineTorqueMultiplier = 0.50

					Dim flag4 As Boolean = Not Me.CheckDist(submarine)
					If flag4 Then

						Dim list2 As List(Of VehicleSeat) = New List(Of VehicleSeat)()
						list2.Add(VehicleSeat.Driver)    '1
						list2.Add(VehicleSeat.Passenger)  '2
						list2.Add(VehicleSeat.RightRear)  '3
						list2.Add(VehicleSeat.LeftRear)   '4

						Dim list3 As List(Of WeaponHash) = New List(Of WeaponHash)()
						list3.Add(Me.Weapselect())  '1
						list3.Add(Me.Weapselect())   '2
						list3.Add(Me.Weapselect())    '3
						list3.Add(Me.Weapselect())     '4

						Try
							For Each vehicleSeat As VehicleSeat In list2
								Dim ped As Ped = submarine.CreatePedOnSeat(vehicleSeat, Me.Navy_Pedselect())

								Script.Wait(5)

								Dim flag5 As Boolean = Entity.Exists(ped)
								If flag5 Then
									Me.createdEntities.Add(ped)
									Me.SetAsCop(ped)

									Dim flag6 As Boolean = list3.Count = 0
								'check if there still weapons in the list, use default case its empty
									If flag6 Then
										list3.Add(Me.Weapselect())

									End If

									'give actual weapon and then remove it from the weapons list, this way we will equip each soldier with one weapon from the list
									ped.Weapons.Give(list3(0), 999, True, True)

									list3.RemoveAt(0)

                        						If vehicleSeat = VehicleSeat.Driver Then
                            						' Set the shooting task for the driver
							
                							Dim TS As TaskSequence = New TaskSequence() 

                								TS.AddTask.VehicleChase(Game.Player.Character)

										TS.AddTask.FightAgainst(Game.Player.Character)

										TS.AddTask.VehicleShootAtPed(Game.Player.Character)

									TS.Close()

										ped.Task.PerformSequence(TS)
										submarine.driver.CanSwitchWeapons = true
										ped.AlwaysKeepTask = True

										TS.Dispose()
									Else

										ped.Task.ShootAt(Game.Player.Character, 99999, CType(3607063905UI, FiringPattern))
									End If

									'set that they may be deleted by the game
									ped.MarkAsNoLongerNeeded()
								End If
							Next
						Finally
							Dim enumerator As List(Of VehicleSeat).Enumerator
								CType(enumerator, IDisposable).Dispose()
								submarine.MarkAsNoLongerNeeded()
						End Try

						Dim flag7 As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
						If flag7 Then
							submarine.Heading = Game.Player.Character.CurrentVehicle.Heading
							submarine.Speed = Game.Player.Character.CurrentVehicle.Speed
						End If
				      End If
			       End If
		      End If
	      End If
	End Sub

	Private Sub Navy_Fleetselect()

		Dim list As List(Of String) = New List(Of String)()

		Me.AddVehModelToList(list, "james")       'Battleship/Warships

		Dim flag As Boolean = list.Count = 0
		If Not flag Then
			Dim source As String = list(Me.myRandomSource.[Next](0, list.Count))
			Dim spawnPosInWater As Vector3 = Me.GetSpawnPosInWater(270.0)

			Dim flag2 As Boolean = spawnPosInWater = Nothing
			If Not flag2 Then
				Dim vehicle As Vehicle = World.CreateVehicle(source, spawnPosInWater)

				Script.Wait(5)

				Dim flag3 As Boolean = Entity.Exists(vehicle)
				If flag3 Then
					Me.createdVehicles.Add(vehicle.Handle)
					Me.createdEntities.Add(vehicle)
					
					 vehicle.LightsOn = true
					 vehicle.EnginePowerMultiplier = 30
					 vehicle.EngineTorqueMultiplier = .30

					Dim flag4 As Boolean = Not Me.CheckDist(vehicle)
					If flag4 Then

						Dim list2 As List(Of VehicleSeat) = New List(Of VehicleSeat)()
						list2.Add(VehicleSeat.Driver)    '1

						Dim list3 As List(Of WeaponHash) = New List(Of WeaponHash)()
						list3.Add(Me.Weapselect())
						Try
							For Each vehicleSeat As VehicleSeat In list2
								Dim ped As Ped = vehicle.CreatePedOnSeat(vehicleSeat, Me.Navy_Pedselect())

						Script.Wait(5)

								Dim flag5 As Boolean = Entity.Exists(ped)
								If flag5 Then
									Me.createdEntities.Add(ped)
									Me.SetAsCop(ped)

									'check if there still weapons in the list, use default case its empty
									Dim flag6 As Boolean = list3.Count = 0
									If flag6 Then
										list3.Add(Me.Weapselect())
								     End If

									'give actual weapon and then remove it from the weapons list, this way we will equip each soldier with one weapon from the list
									ped.Weapons.Give(list3(0), 999, True, True)

									list3.RemoveAt(0)

									'set the shooting task for each soldier

									Dim flag7 As Boolean = vehicleSeat = vehicleSeat.Driver
									If flag7 Then

										ped.Task.ShootAt(Game.Player.Character, 99999, CType(3607063905UI, FiringPattern))
										ped.DrivingStyle = DrivingStyle.Rushed
										ped.RelationshipGroup = IsCop(ped)
										ped.AlwaysKeepTask = True
									Else

										ped.Task.FightAgainst(Game.Player.Character, 9999)
									End If

									'set that they may be deleted by the game
									ped.MarkAsNoLongerNeeded()

								End If
							Next
						Finally
							Dim enumerator As List(Of VehicleSeat).Enumerator
							CType(enumerator, IDisposable).Dispose()
							vehicle.MarkAsNoLongerNeeded()
					 End Try

						Dim flag8 As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
						If flag8 Then
							vehicle.Heading = Game.Player.Character.CurrentVehicle.Heading
							vehicle.Speed = Game.Player.Character.CurrentVehicle.Speed
						End If
					End If
				 End If
			 End If
		 End If
	End Sub

	Private Sub NavySeal_select()

		Dim list As List(Of String) = New List(Of String)()

		Me.AddVehModelToList(list, "dinghy5")
		Me.AddVehModelToList(list, "dinghym")

		Dim flag As Boolean = list.Count = 0
		If Not flag Then
			Dim source As String = list(Me.myRandomSource.[Next](0, list.Count))
			Dim spawnPosInWater As Vector3 = Me.GetSpawnPosInWater(180.0)

			Dim flag2 As Boolean = spawnPosInWater = Nothing
			If Not flag2 Then
				Dim vehicle As Vehicle = World.CreateVehicle(source, spawnPosInWater)

				Script.Wait(5)

				Dim flag3 As Boolean = Entity.Exists(vehicle)
				If flag3 Then
					Me.createdVehicles.Add(vehicle.Handle)
					Me.createdEntities.Add(vehicle)

					Dim flag4 As Boolean = Not Me.CheckDist(vehicle)

					If flag4 Then
						Dim list2 As List(Of VehicleSeat) = New List(Of VehicleSeat)()
						list2.Add(VehicleSeat.Driver)    '1
						list2.Add(VehicleSeat.Passenger)  '2
						list2.Add(VehicleSeat.RightRear)   '3
						list2.Add(VehicleSeat.LeftRear)     '4
						list2.Add(VehicleSeat.ExtraSeat1)    '5

						Dim list3 As List(Of WeaponHash) = New List(Of WeaponHash)()
						list3.Add(Me.Weapselect())   '1
						list3.Add(Me.Weapselect())    '2
						list3.Add(Me.Weapselect())     '3
						list3.Add(Me.Weapselect())      '4
						list3.Add(Me.Weapselect())       '5

				                Dim list4 As List(Of WeaponComponent) = New List(Of WeaponComponent)()
					        list4.Add(Me.weapcomponselect())  '1
					        list4.Add(Me.weapcomponselect())  '2
					        list4.Add(Me.weapcomponselect())  '3
					        list4.Add(Me.weapcomponselect())  '4
					        list4.Add(Me.weapcomponselect())  '5
						Try
							For Each vehicleSeat As VehicleSeat In list2
								Dim ped As Ped = vehicle.CreatePedOnSeat(vehicleSeat, "navyseal")

								Script.Wait(5)

								Dim flag5 As Boolean = Entity.Exists(ped)
								If flag5 Then
									Me.createdEntities.Add(ped)
									Me.SetAsCop(ped)

									'check if there still weapons in the list, use default case its empty
									Dim flag6 As Boolean = list3.Count = 0
									If flag6 Then
										list3.Add(Me.Weapselect())
										list4.Add(Me.weapcomponselect())
									End If

									'give actual weapon and then remove it from the weapons list, this way we will equip each soldier with one weapon from the list
									ped.Weapons.Give(list3(0), 999, True, True)

								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.AdvancedRifle, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.CarbineRifle, WeaponComponent.AtArFlsh })
                                                                        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.BullpupRifle, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.SpecialCarbine, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.SMG, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.AssaultSMG, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.HeavyShotgun, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.AssaultShotgun, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.MarksmanRifle, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.Pistol, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.CombatPistol, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.CombatPDW, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.Pistol50, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.HeavyPistol, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.Revolver, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.GrenadeLauncher, WeaponComponent.AtArFlsh })
								        [Function].[Call](Hash.GIVE_WEAPON_COMPONENT_TO_PED, New InputArgument() { ped, WeaponHash.PumpShotgun, WeaponComponent.AtArFlsh })

									list3.RemoveAt(0)
									list4.RemoveAt(0)

									'set the shooting task for each soldier

									Dim flag7 As Boolean = vehicleSeat = vehicleSeat.Driver
									If flag7 Then

										ped.Task.ShootAt(Game.Player.Character, 99999, CType(3607063905UI, FiringPattern))
										ped.DrivingStyle = DrivingStyle.Rushed
										ped.RelationshipGroup = IsCop(ped)
										ped.AlwaysKeepTask = True
									Else

										ped.Task.FightAgainst(Game.Player.Character, 9999)
									End If

									'set that they may be deleted by the game
									ped.MarkAsNoLongerNeeded()
								End If
							Next
						Finally
							Dim enumerator As List(Of VehicleSeat).Enumerator
							CType(enumerator, IDisposable).Dispose()
							vehicle.MarkAsNoLongerNeeded()
						End Try

						Dim flag8 As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
						If flag8 Then
							vehicle.Heading = Game.Player.Character.CurrentVehicle.Heading
							vehicle.Speed = Game.Player.Character.CurrentVehicle.Speed
						End If
					End If
				End If
			End If
		End If
	End Sub

	Private Sub Coastguard_heliselect()

		Dim list As List(Of String) = New List(Of String)()

		Me.AddVehModelToList(list, "cgheli")

		Dim flag As Boolean = list.Count = 0
		If Not flag Then
			Dim source As String = list(Me.myRandomSource.[Next](0, list.Count))
			Dim vehicle As Vehicle = World.CreateVehicle(source, Me.GetHeliSpawnPos(180.0))

			Script.Wait(5)

			Dim flag2 As Boolean = Entity.Exists(vehicle)
			If flag2 Then
				Me.createdVehicles.Add(vehicle.Handle)
				Me.createdEntities.Add(vehicle)
				[Function].[Call](Hash._0xA178472EBB8AE60D, New InputArgument() {vehicle})

				vehicle.SearchLightOn = true

				Dim flag3 As Boolean = Not Me.CheckDist(vehicle)

				If flag3 Then
					Dim list2 As List(Of VehicleSeat) = New List(Of VehicleSeat)()
					list2.Add(VehicleSeat.Driver)   '1
					list2.Add(VehicleSeat.Passenger) '2
					list2.Add(VehicleSeat.RightRear)  '3
					list2.Add(VehicleSeat.LeftRear)    '4

					Dim list3 As List(Of WeaponHash) = New List(Of WeaponHash)()
					list3.Add(Me.Weapselect())  '1
					list3.Add(Me.Weapselect())   '2
					list3.Add(Me.Weapselect())    '3
					list3.Add(Me.Weapselect())     '4
					Try
						For Each vehicleSeat As VehicleSeat In list2

							Dim ped As Ped = vehicle.CreatePedOnSeat(vehicleSeat, "s_m_y_uscg_01")

						Script.Wait(5)

							Dim flag4 As Boolean = Entity.Exists(ped)
							If flag4 Then
								Me.createdEntities.Add(ped)
								Me.SetAsCop(ped)

								'check if there still weapons in the list, use default case its empty
								Dim flag5 As Boolean = list3.Count = 0
								If flag5 Then
									list3.Add(Me.Weapselect())
								End If

								'give actual weapon and then remove it from the weapons list, this way we will equip each soldier with one weapon from the list
								ped.Weapons.Give(list3(0), 999, True, True)

								list3.RemoveAt(0)

								'set the shooting task for each soldier
								Dim flag6 As Boolean = vehicleSeat = vehicleSeat.Driver
								If flag6 Then

									ped.Task.ShootAt(Game.Player.Character, 9999)
									ped.DrivingStyle = DrivingStyle.Rushed
									ped.AlwaysKeepTask = True	
								Else
									
									ped.Task.ShootAt(Game.Player.Character, 9999)
								End If

								'set that they may be deleted by the game
								ped.MarkAsNoLongerNeeded()
							End If
						Next
					Finally
						Dim enumerator As List(Of VehicleSeat).Enumerator
						CType(enumerator, IDisposable).Dispose()
						vehicle.MarkAsNoLongerNeeded()
					End Try

					Dim flag7 As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
					If flag7 Then
						vehicle.Heading = Game.Player.Character.CurrentVehicle.Heading
						vehicle.Speed = Game.Player.Character.CurrentVehicle.Speed
					End If
				End If
			End If
		End If
	End Sub

	Private Sub Airforce_ParaTrooperselect()

		Dim list As List(Of String) = New List(Of String)()

		Me.AddVehModelToList(list, "Cargobob")

		Dim flag As Boolean = list.Count = 0
		If Not flag Then
			Dim source As String = list(Me.myRandomSource.[Next](0, list.Count))
			Dim vehicle As Vehicle = World.CreateVehicle(source, Me.GetHeliSpawnPos(180.0))

			Script.Wait(5)
				'Dim flag2 As Boolean = vehicle IsNot Nothing
				'If flag2 Then

			Dim flag2 As Boolean = Entity.Exists(vehicle)
			If flag2 Then
				Me.createdVehicles.Add(vehicle.Handle)
				Me.createdEntities.Add(vehicle)
				[Function].[Call](Hash._0xA178472EBB8AE60D, New InputArgument() {vehicle})

    					vehicle.LockStatus = VehicleLockStatus.Unlocked
					vehicle.OpenDoor(VehicleDoor.Backleftdoor, false, true)
					vehicle.OpenDoor(VehicleDoor.Backrightdoor, false, true)

				Dim flag3 As Boolean = Not Me.CheckDist(vehicle)
				If flag3 Then

					Dim list2 As List(Of VehicleSeat) = New List(Of VehicleSeat)()
					list2.Add(VehicleSeat.Driver)    '1
					list2.Add(VehicleSeat.RightRear)  '2
					list2.Add(VehicleSeat.LeftRear)  '3
						list2.Add(VehicleSeat.ExtraSeat1)   '4
						list2.Add(VehicleSeat.ExtraSeat2)  '5
						list2.Add(VehicleSeat.ExtraSeat3)  '6
						list2.Add(VehicleSeat.ExtraSeat4)  '7

					Dim list3 As List(Of WeaponHash) = New List(Of WeaponHash)()
					list3.Add(CType(2210333304UI, WeaponHash))   '1
					list3.Add(CType(2210333304UI, WeaponHash))   '2 
					list3.Add(CType(2210333304UI, WeaponHash))    '3
					list3.Add(CType(2210333304UI, WeaponHash))     '4
					list3.Add(Native.WeaponHash.AssaultSMG)                '5
					list3.Add(Native.WeaponHash.CombatMG)                  '6
					list3.Add(Native.WeaponHash.SMG)               	'7

					Dim list4 As List(Of WeaponHash) = New List(Of WeaponHash)()
					list4.Add(Native.WeaponHash.Parachute)   '1
					list4.Add(Native.WeaponHash.Parachute)    '2 
					list4.Add(Native.WeaponHash.Parachute)     '3
					list4.Add(Native.WeaponHash.Parachute)      '4
					list4.Add(Native.WeaponHash.Parachute)        '5
					list4.Add(Native.WeaponHash.Parachute)          '6
					list4.Add(Native.WeaponHash.Parachute)           '7
					Try
						For Each vehicleSeat As VehicleSeat In list2

							Dim ped As Ped = vehicle.CreatePedOnSeat(vehicleSeat, Me.Paratrooper_Pedselect())

							Dim flag4 As Boolean = Entity.Exists(ped)
							If flag4 Then

								Me.createdEntities.Add(ped)
								Me.SetAsCop(ped)
    							 End If

								ped.Weapons.Give(Native.WeaponHash.Parachute, 1, True, True)

								ped.Weapons.Give(Native.WeaponHash.CombatMG, 999, True, True)

								Dim landingType As Integer = Native.Function.Call(Of Integer)(Hash.GET_PED_PARACHUTE_LANDING_TYPE, ped.Handle) ' Get the landing type
								
                						Dim TS As TaskSequence = New TaskSequence() 

                						 TS.AddTask.ParachuteTo(Game.Player.Character.Position)

									TS.AddTask.FightAgainst(Game.Player.Character)

									TS.AddTask.RunTo(Game.Player.Character.Position)

									TS.AddTask.FightAgainst(Game.Player.Character)
								      TS.Close()

								    'vehicle.driver.Task.Wait(4000)
								ped.Task.PerformSequence(TS)
								ped.AlwaysKeepTask = True

								TS.Dispose()

								' check if there still weapons in the list, use default case its empty
								If list3.Count = 0 Then

									list3.Add(CType(2210333304UI, WeaponHash))
					 			End If

								'give actual weapon and then remove it from the weapons list, this way we will equip each soldier with one weapon from the list
								ped.Weapons.Give(list3(0), 999, True, True)

								list3.RemoveAt(0)

								If list4.Count = 0 Then
									list4.Add(Native.WeaponHash.Parachute)

									Ped.Weapons.Give(list4(0), 999, True, True)

									list4.RemoveAt(0)
							
                                                  		'set the shooting task for each soldier
									If vehicleSeat = VehicleSeat.Driver Then

									ped.Task.ShootAt(Game.Player.Character, 99999, CType(2437838959UI, FiringPattern))
									'ped.DrivingStyle = DrivingStyle.Normal
									ped.RelationshipGroup = IsCop(ped)
								        vehicle.driver.MarkAsNoLongerNeeded()
									ped.AlwaysKeepTask = True
								End If

									ped.MarkAsNoLongerNeeded()
									'vehicle.driver.MarkAsNoLongerNeeded()
							End If
						Next
								Catch ex As Exception
								UI.Notify("~r~Error:~s~ " & ex.Message)
					Finally
						Dim enumerator As List(Of VehicleSeat).Enumerator
						CType(enumerator, IDisposable).Dispose()
						vehicle.MarkAsNoLongerNeeded()
				 End Try

					Dim flag5 As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
					If flag5 Then
						vehicle.Heading = Game.Player.Character.CurrentVehicle.Heading
						vehicle.Speed = Game.Player.Character.CurrentVehicle.Speed
					End If
				End If
			End If
		End If
	End Sub

	Private Sub Airforce_Spaceforceselect()

		Dim list As List(Of String) = New List(Of String)()

		Me.addVehModelToList(list, "thruster")

		Dim flag As Boolean = list.Count = 0
		If Not flag Then
			Dim source As String = list(Me.myRandomSource.[Next](0, list.Count))
			Dim vehicle As Vehicle = World.CreateVehicle(source, Me.GetHeliSpawnPos(180.0F))

			Script.Wait(5)

			Dim flag2 As Boolean = Entity.Exists(vehicle)
			If flag2 Then
				Me.createdVehicles.Add(vehicle.Handle)
				Me.createdEntities.Add(vehicle)

				[Function].[Call](Hash._0xA178472EBB8AE60D, New InputArgument() { vehicle })
				[Function].[Call](Hash._0x1F2AA07F00B3217A, New InputArgument() { vehicle, 0 })		   'sets veh mod kit
				[Function].[Call](Hash._0x6AF0636DDEDCB6DD, New InputArgument() { vehicle, 10, 0, True })    'sets veh mod
				[Function].[Call](Hash.CONTROL_MOUNTED_WEAPON, New InputArgument() { vehicle, True })		'sets control mounted weapon

				Dim flag3 As Boolean = Not Me.checkDist(vehicle)
				If flag3 Then

					Dim list2 As List(Of VehicleSeat) = New List(Of VehicleSeat)()
					list2.Add(VehicleSeat.Driver)     '1

					Dim list3 As List(Of WeaponHash) = New List(Of WeaponHash)()
					list3.Add(Native.WeaponHash.MicroSMG)   '1     
					Try
						For Each vehicleSeat As VehicleSeat In list2
							Dim ped As Ped = vehicle.CreatePedOnSeat(vehicleSeat, Me.Army_pedselect())

							Script.Wait(5)

							Dim flag4 As Boolean = Entity.Exists(ped)
							If flag4 Then
								Me.createdEntities.Add(ped)
								Me.setAsCop(ped)

							vehicle.driver.CanBeDraggedOutOfVehicle = true
							vehicle.Driver.CanSwitchWeapons = true
							vehicle.driver.Weapons.Give(WeaponHash.Minigun, 9999, True, True)

                					Dim TS As TaskSequence = New TaskSequence() 

									TS.AddTask.VehicleChase(Game.Player.Character)

									TS.AddTask.FightAgainst(Game.Player.Character)

									TS.AddTask.AimAt(Game.Player.Character, 9999)

									TS.AddTask.VehicleShootAtPed(Game.Player.Character)
								    TS.Close()

								ped.Task.PerformSequence(TS)
								ped.AlwaysKeepTask = True

								TS.Dispose()

                                                    'check if there still weapons in the list, use default case its empty
								Dim flag5 As Boolean = list3.Count = 0
								If flag5 Then

								list3.Add(CType(2210333304UI, WeaponHash))
							End If

                                                   'give actual weapon and then remove it from the weapons list, this way we will equip each soldier with one weapon from the list
								ped.Weapons.Give(list3(0), 999, True, True)

								list3.RemoveAt(0)

                                                  'set the shooting task for each soldier
								Dim flag6 As Boolean = vehicleSeat = VehicleSeat.Driver
								If flag6 Then

									ped.Task.ShootAt(Game.Player.Character, 99999, CType(2437838959UI, FiringPattern))
									ped.DrivingStyle = DrivingStyle.Rushed
									ped.AlwaysKeepTask = True
								End If

                                                                    'set that they may be deleted by the game
                                                                         ped.MarkAsNoLongerNeeded()
                  			 				 vehicle.MarkAsNoLongerNeeded()
								End If
						     Next
					Finally
						Dim enumerator As List(Of VehicleSeat).Enumerator
						CType(enumerator, IDisposable).Dispose()
					End Try

					Dim flag7 As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
					If flag7 Then
						vehicle.Heading = Game.Player.Character.CurrentVehicle.Heading
						vehicle.Speed = Game.Player.Character.CurrentVehicle.Speed
					End If
				End If
			End If
		End If
	End Sub

	Private Sub SetAsCop(p As Ped)
		Dim flag As Boolean = Me.copsGroup IsNot Nothing
		If flag Then
			Me.copsGroup.Add(p, False)
		End If

		[Function].[Call](Hash._0xBB03C38DD3FB7FFD, New InputArgument() {p, True})
	End Sub

	Private Function CheckDist(e As Entity) As Boolean

		Dim flag As Boolean = World.GetDistance(Game.Player.Character.Position, e.Position) < 30.0F
		Dim result As Boolean
		If flag Then

			e.Delete()
			result = True
		Else
			result = False
		End If
		Return result
	End Function

	Private Function Army_Pedselect() As String
		Dim result As String
		Select Case Me.myRandomSource.[Next](6)
			Case 0
				result = "s_m_y_blackops_03"
			Case 1
				result = "s_m_m_Marine_02"
			Case 2
				result = "s_m_y_Marine_01"
			Case 3
				result = "s_m_y_Marine_02"
			Case 4
				result = "s_m_y_Marine_03"
			Case Else
				result = "s_m_y_blackops_01"
		End Select
		Return result
	End Function

	Private Function Cia_Pedselect() As String
    		Dim result As String
    		Select Case Me.myRandomSource.[Next](3)
        		Case 0
            			result = "philips_graves_shadow"
        		Case 1
            			result = "s_m_m_highsec_01"
        		Case Else
           			 result = "commando"
    		End Select
    		Return result
	End Function

	Private Function Fib_Pedselect() As String
    		Dim result As String
    		Select Case Me.myRandomSource.[Next](3)
        		Case 0
          			result = "s_m_y_fibswat_01"
        		Case 1
          			result = "juggernaut"
        		Case Else
            			result = "u_m_y_juggernaut_01"
    		End Select
    		Return result
	End Function

	Private Function ParaTrooper_Pedselect() As String
    		Dim result As String
    		Select Case Me.myRandomSource.[Next](3)
        		Case 0
            			result = "bbeardNB"
        		Case 1
            			result = "shadow_ar_operator"
        		Case Else
            			result = "bbeardSHNB"
    		End Select
    		Return result
	End Function

	Private Function Navy_Pedselect() As String
    		Dim result As String
    		Select Case Me.myRandomSource.[Next](2)
        		Case 1
            			result = "s_m_m_marine_01"
        		Case Else
            			result = "s_m_m_marine_02"
    		End Select
    		Return result
	End Function

	Private Function Weapcomponselect() As WeaponComponent

		Dim num As Integer = Me.myRandomSource.[Next](17)

		Dim flag As Boolean = num >= 0 AndAlso num <= 3
		Dim result As WeaponComponent
		If flag Then

			result = WeaponComponent.AtArFlsh 'Flashlight
		Else
			flag = (num >= 4 AndAlso num <= 10)
			If flag Then
				result = WeaponComponent.AtArFlsh
			Else
				flag = (num >= 11 AndAlso num <= 15)
				If flag Then
					result = WeaponComponent.AtArFlsh
				Else
					flag = (num >= 16 AndAlso num <= 20)
					If flag Then
						result = WeaponComponent.AtArFlsh
					Else
						flag = (num >= 21 AndAlso num <= 23)
						If flag Then
							result = WeaponComponent.AtArFlsh
						Else
							flag = (num >= 24 AndAlso num <= 26)
							If flag Then
								result = WeaponComponent.AtArFlsh
							Else
								flag = (num >= 27 AndAlso num <= 29)
								If flag Then
									result = WeaponComponent.AtArFlsh
								Else
									flag = (num >= 30 AndAlso num <= 32)
									If flag Then
										result = WeaponComponent.AtArFlsh
									Else
										flag = (num >= 41 AndAlso num <= 43)
										If flag Then
											result = WeaponComponent.AtArFlsh
										Else
											flag = (num >= 47 AndAlso num <= 49)
											If flag Then
												result = WeaponComponent.AtPiFlsh
											Else
												flag = (num >= 50 AndAlso num <= 53)
												If flag Then
													result = WeaponComponent.AtPiFlsh
												Else
													flag = (num = 54)
													If flag Then
														result = WeaponComponent.AtArFlsh
													Else
														flag = (num = 55)
														If flag Then
															result = WeaponComponent.AtPiFlsh
														Else
															flag = (num = 56)
															If flag Then
																result = WeaponComponent.AtPiFlsh
															Else
																flag = (num = 57)
																If flag Then
																	result = WeaponComponent.AtPiFlsh
																Else
																	flag = (num = 58)
																	If flag Then
																		result = WeaponComponent.AtArFlsh
																	Else
																		result = WeaponComponent.AtArFlsh
																	End If
																End If
															End If
														End If
													End If
												End If
											End If
										End If
									End If
								End If
							End If
						End If
					End If
				End If
			End If
		End If
		Return result
	End Function

	Private Function Weapselect() As WeaponHash

		Dim num As Integer = Me.myRandomSource.[Next](64)

		Dim flag As Boolean = num >= 0 AndAlso num <= 3
		Dim result As WeaponHash
		If flag Then
			result = CType(2937143193UI, WeaponHash) 'Native.WeaponHash.AdvancedRifle
		Else
			flag = (num >= 4 AndAlso num <= 10)
			If flag Then
				result = CType(2210333304UI, WeaponHash) 'Native.WeaponHash.CarbineRifle
			Else
				flag = (num >= 11 AndAlso num <= 15)
				If flag Then
					result = WeaponHash.BullpupRifle
				Else
					flag = (num >= 16 AndAlso num <= 20)
					If flag Then
						result = CType(3231910285UI, WeaponHash) 'Native.WeaponHash.SpecialCarbine
					Else
						flag = (num >= 21 AndAlso num <= 23)
						If flag Then
							result = WeaponHash.SMG
						Else
							flag = (num >= 24 AndAlso num <= 26)
							If flag Then
								result = CType(4024951519UI, WeaponHash) 'Native.WeaponHash.AssaultSMG
							Else
								flag = (num >= 27 AndAlso num <= 29)
								If flag Then
									result = WeaponHash.HeavyShotgun
								Else
									flag = (num >= 30 AndAlso num <= 32)
									If flag Then
										result = CType(3800352039UI, WeaponHash) 'Native.WeaponHash.AssaultShotgun
									Else
										flag = (num >= 33 AndAlso num <= 35)
										If flag Then
											result = WeaponHash.SweeperShotgun
										Else
											flag = (num >= 36 AndAlso num <= 37)
											If flag Then
												result = WeaponHash.CombatMG
											Else
												flag = (num >= 38 AndAlso num <= 39)
												If flag Then
													result = WeaponHash.SniperRifle
												Else
													flag = (num >= 40 AndAlso num <= 42)
													If flag Then
														result = WeaponHash.HeavySniper
													Else
														flag = (num >= 41 AndAlso num <= 43)
														If flag Then
															result = CType(3342088282UI, WeaponHash) 'Native.WeaponHash.MarksmanRifle
														Else
															flag = (num >= 44 AndAlso num <= 46)
															If flag Then
																result = WeaponHash.Minigun
															Else
																flag = (num >= 47 AndAlso num <= 49)
																If flag Then
																	result = WeaponHash.Pistol
																Else
																	flag = (num >= 50 AndAlso num <= 53)
																	If flag Then
																		result = WeaponHash.CombatPistol
																	Else
																		flag = (num = 54)
																		If flag Then
																			result = WeaponHash.CombatPDW
																		Else
																			flag = (num = 55)
																			If flag Then
																				result = CType(2578377531UI, WeaponHash) 'Native.WeaponHash.Pistol50
																			Else
																				flag = (num = 56)
																				If flag Then
																					result = CType(3523564046UI, WeaponHash) 'Native.WeaponHash.HeavyPistol
																				Else
																					flag = (num = 57)
																					If flag Then
																						result = CType(3249783761UI, WeaponHash) 'Native.WeaponHash.Revolver
																					Else
																						flag = (num = 58)
																						If flag Then
																							result = CType(2726580491UI, WeaponHash) 'Native.WeaponHash.GrenadeLauncher
																						Else
																							flag = (num = 59)
																							If flag Then
																								result = WeaponHash.HomingLauncher
																							Else
																								flag = (num = 60)
																								If flag Then
																									result = WeaponHash.CompactGrenadeLauncher
																								Else
																									result = WeaponHash.PumpShotgun
																								End If
																							End If
																						End If
																					End If
																				End If
																			End If
																		End If
																	End If
																End If
															End If
														End If
													End If
												End If
											End If
										End If
									End If
								End If
							End If
						End If
					End If
				End If
			End If
		End If
		Return result
	End Function


	Private Function GetPedType(p As Ped) As ArmyAtSixStars.PedType
		Try
			Return CType([Function].[Call](Of Integer)(Hash._0xFF059E1E4C01E63C, New InputArgument() {p}), ArmyAtSixStars.PedType)
		Catch ex As Exception
		End Try

		Return CType((-1), ArmyAtSixStars.PedType)
	End Function

	Private Function IsCop(p As Entity) As Boolean
		Dim pedType As ArmyAtSixStars.PedType = Me.GetPedType(CType(p, Ped))
		Return pedType = ArmyAtSixStars.PedType.Cop OrElse pedType = ArmyAtSixStars.PedType.Army OrElse pedType = ArmyAtSixStars.PedType.SWAT
	End Function

	Private Function GetSpawnPos(Optional pMinRandomDist As Double = 90.0) As Vector3

		Dim vector As Vector3 = Nothing
		Dim flag As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
		If flag Then
			Me.latestCopCarHeading = CDbl((Game.Player.Character.CurrentVehicle.Heading + 180.0F))
			Me.latestCopCarSpeed = CDbl(Game.Player.Character.CurrentVehicle.Speed)
		Else
			Me.latestCopCarHeading = CDbl((Game.Player.Character.Heading + 180.0F))
			Me.latestCopCarSpeed = 5.0
		End If

		Dim flag3 As Boolean = vector = Nothing
		If flag3 Then
			Dim direction As Vector3 = GameplayCamera.Direction
			direction.Z = 0F
			vector = Game.Player.Character.Position - direction * CSng(pMinRandomDist)
			vector.Z = World.GetGroundHeight(vector) + 1.0F
			vector = World.GetNextPositionOnStreet(vector)
		End If

		[Function].[Call](Hash._0xA56F01F3765B93A0, New InputArgument() {vector.X, vector.Y, vector.Z, 5.0F, True, False, True, False})
		Return vector
	End Function

	Private Function GetHeliSpawnPos(Optional pMinRandomDist As Double = 180.0) As Vector3

		Dim vector As Vector3 = Nothing
		Dim flag As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
		If flag Then
			Me.latestCopCarHeading = CDbl((Game.Player.Character.CurrentVehicle.Heading + 180.0F))
			Me.latestCopCarSpeed = CDbl(Game.Player.Character.CurrentVehicle.Speed)
		Else
			Me.latestCopCarHeading = CDbl((Game.Player.Character.Heading + 180.0F))
			Me.latestCopCarSpeed = 5.0
		End If

		Dim flag3 As Boolean = vector = Nothing
		If flag3 Then
			Dim direction As Vector3 = GameplayCamera.Direction
			direction.Z = 0F
			vector = (Game.Player.Character.Position - direction * CSng(pMinRandomDist)).Around(50.0F)
		End If

		vector.Z = Math.Max(Game.Player.Character.Position.Z + 50.0F, 50.0F)
		[Function].[Call](Hash._0xA56F01F3765B93A0, New InputArgument() {vector.X, vector.Y, vector.Z, 5.0F, True, False, True, False})
		Return vector
	End Function

	Private Function GetMotorcycleSpawnPos(Optional pminRandomDist As Double = 60.0) As Vector3

    		Dim offset As Vector3 = Vector3.WorldUp * 2.0F
    		Dim playerPosition As Vector3 = Game.Player.Character.Position

	    ' Calculate the final spawn position for motorcycles
    		Dim motorcycleSpawnPos As Vector3 = playerPosition - Game.Player.Character.ForwardVector * pminRandomDist + offset

	    Return motorcycleSpawnPos
	End Function

	Private Function GetSpawnPosInWater(Optional pMinRandomDist As Double = 180.0) As Vector3

		Dim vector As Vector3 = Nothing
		Dim flag As Boolean = Entity.Exists(Game.Player.Character.CurrentVehicle)
		If flag Then

			Me.latestCopCarHeading = CDbl((Game.Player.Character.CurrentVehicle.Heading + 180.0F))
			Me.latestCopCarSpeed = CDbl(Game.Player.Character.CurrentVehicle.Speed)
		Else
			Me.latestCopCarHeading = CDbl((Game.Player.Character.Heading + 180.0F))
			Me.latestCopCarSpeed = 5.0
		End If

		Dim flag3 As Boolean = vector = Nothing
		If flag3 Then
			Dim direction As Vector3 = GameplayCamera.Direction
			direction.Z = 0F
			vector = (Game.Player.Character.Position - direction * CSng(pMinRandomDist)).Around(50.0F)
			Dim flag4 As Boolean = World.GetGroundHeight(vector) > -2.0F
			If flag4 Then
				vector = Nothing
			End If
		End If

		[Function].[Call](Hash._0xA56F01F3765B93A0, New InputArgument() {vector.X, vector.Y, vector.Z, 5.0F, True, False, True, False})
		Return vector
	End Function

	Private Function GetPlaneSpawnPos(heading As Single) As Vector3

		Dim playerPos As Vector3 = Game.Player.Character.Position
		Dim playerForward As Vector3 = Game.Player.Character.ForwardVector
		Dim spawnPos As Vector3 = playerPos + playerForward * 100.0F
		spawnPos.Z += 500.0F

		Return spawnPos
	End Function

	Private Sub ResetScriptState()
		Me.bSixStars = False
		Me.crimes = 0
		Me.damagedPeds.Clear()
		Me.copsGroup = Nothing
		Me.relationshipGroup = Nothing
		Me.bLoadAnimatedGif = True
		Me.animatedGifFiles_1.Clear()
		Me.animatedGifFiles_currentImages.Clear()
		Me.latestCopCarHeading = 0.0
		Me.latestCopCarSpeed = 0.0
		Me.createdVehicles.Clear()
		Me.createdEntities.Clear()
	End Sub

	Private myRandomSource As Random

	Private bSixStars As Boolean

	Private crimes As Integer

	Private timerCheckKilledPeds As DateTime

	Private damagedPeds As List(Of Integer)

	Private timerDispatch As DateTime

	Private copsGroup As PedGroup

	Private relationshipGroup As PedGroup

	Private bLoadAnimatedGif As Boolean

	Private animatedGifFiles_1 As List(Of String)

	Private animatedGig_timerNextImage As DateTime

	Private animatedGifFiles_currentImages As List(Of String)

	Private timerShowWNews As Date

	Private bShowWNews As Boolean = False

	Private latestCopCarHeading As Double

	Private latestCopCarSpeed As Double

	Private createdVehicles As List(Of Integer)

	Private createdEntities As List(Of Entity)

	Public Enum PedType
		Player = 1
		Male = 4
		Female = 5
		Cop = 6
		Human = 26
		SWAT = 27
		Animal = 28
		Army = 29
	End Enum
End Class